searchData={"items":[{"type":"module","title":"IgniterCss","doc":"","ref":"IgniterCss.html"},{"type":"module","title":"IgniterCss.CSS.CssProcessor","doc":"A module that provides higher-level CSS processing functionality by leveraging\nthe CSS.Parser module.","ref":"IgniterCss.CSS.CssProcessor.html"},{"type":"function","title":"IgniterCss.CSS.CssProcessor.apply_browser_compatibility/1","doc":"Applies browser compatibility fixes to CSS.\n\nMakes CSS work across browsers by:\n1. Adding vendor prefixes for properties that need them\n2. Adding standard fallbacks for newer CSS features\n3. Adding the .hide-scrollbar modifier as needed","ref":"IgniterCss.CSS.CssProcessor.html#apply_browser_compatibility/1"},{"type":"function","title":"Returns - IgniterCss.CSS.CssProcessor.apply_browser_compatibility/1","doc":"The CSS with compatibility fixes applied","ref":"IgniterCss.CSS.CssProcessor.html#apply_browser_compatibility/1-returns"},{"type":"function","title":"IgniterCss.CSS.CssProcessor.extract_critical_css/2","doc":"Extracts critical CSS by identifying and extracting all styles needed for above-the-fold content.","ref":"IgniterCss.CSS.CssProcessor.html#extract_critical_css/2"},{"type":"function","title":"Parameters - IgniterCss.CSS.CssProcessor.extract_critical_css/2","doc":"* `css_content` - The full CSS content as a string\n  * `critical_selectors` - List of selectors considered critical for above-the-fold content","ref":"IgniterCss.CSS.CssProcessor.html#extract_critical_css/2-parameters"},{"type":"function","title":"Returns - IgniterCss.CSS.CssProcessor.extract_critical_css/2","doc":"A tuple with `{critical_css, non_critical_css}`","ref":"IgniterCss.CSS.CssProcessor.html#extract_critical_css/2-returns"},{"type":"function","title":"IgniterCss.CSS.CssProcessor.merge_css_files/2","doc":"Merges multiple CSS files into one optimized stylesheet.","ref":"IgniterCss.CSS.CssProcessor.html#merge_css_files/2"},{"type":"function","title":"Parameters - IgniterCss.CSS.CssProcessor.merge_css_files/2","doc":"* `css_files` - Map of `{filename, content}` pairs\n  * `opts` - Options (same as process_for_production)","ref":"IgniterCss.CSS.CssProcessor.html#merge_css_files/2-parameters"},{"type":"function","title":"Returns - IgniterCss.CSS.CssProcessor.merge_css_files/2","doc":"The merged and optimized CSS","ref":"IgniterCss.CSS.CssProcessor.html#merge_css_files/2-returns"},{"type":"function","title":"IgniterCss.CSS.CssProcessor.process_for_production/2","doc":"Processes a CSS file for production by:\n1. Adding vendor prefixes for browser compatibility\n2. Removing duplicate rules\n3. Sorting properties for better diff comparison\n4. Minifying the CSS","ref":"IgniterCss.CSS.CssProcessor.html#process_for_production/2"},{"type":"function","title":"Parameters - IgniterCss.CSS.CssProcessor.process_for_production/2","doc":"* `css_content` - The CSS content as a string\n  * `opts` - Options for processing:\n    * `:minify` - Whether to minify the output (default: `true`)\n    * `:add_prefixes` - Whether to add vendor prefixes (default: `true`)\n    * `:sort` - Whether to sort properties (default: `true`)\n    * `:remove_duplicates` - Whether to remove duplicates (default: `true`)","ref":"IgniterCss.CSS.CssProcessor.html#process_for_production/2-parameters"},{"type":"function","title":"Returns - IgniterCss.CSS.CssProcessor.process_for_production/2","doc":"The processed CSS as a string","ref":"IgniterCss.CSS.CssProcessor.html#process_for_production/2-returns"},{"type":"module","title":"IgniterCss.Helpers","doc":"A module that contains helper functions for IgniterCss. For example it helps to normalize the\noutput of the NIFs, read and validate the file, and call the NIF function with the\ngiven file path or content.","ref":"IgniterCss.Helpers.html"},{"type":"function","title":"IgniterCss.Helpers.call_nif_fn/4","doc":"Call the NIF function with the given file path or content and return the result.\nIt helps to change the function name as atom based on its caller function.\n\n```elixir\ncall_nif_fn(\"/path/to/file.js\", __ENV__.function, fn content -> content end, :path)\ncall_nif_fn(\"file content\", __ENV__.function, fn content -> content end)\ncall_nif_fn(\"file content\", __ENV__.function, fn content -> content end, :content)\n```","ref":"IgniterCss.Helpers.html#call_nif_fn/4"},{"type":"macro","title":"IgniterCss.Helpers.normalize_output/2","doc":"Normalize the output of the NIFs. It is a macro and returns a tuple with the first\nelement as the output, the second element as the caller function name, and the\nthird element as the status.\n\n```elixir\nrequire IgniterCss.Helpers\nnormalize_output({:ok, :fun_atom, result}, __ENV__.function)\nnormalize_output({:error, :fun_atom, result}, __ENV__.function)\n```","ref":"IgniterCss.Helpers.html#normalize_output/2"},{"type":"function","title":"IgniterCss.Helpers.read_and_validate_file/1","doc":"Read and validate the file. It returns the file content if the file exists and the\nextension is `.js`, `.css`, or `.ts`, otherwise, it returns an error tuple.\n\n```elixir\nread_and_validate_file(\"/path/to/file.js\")\n```","ref":"IgniterCss.Helpers.html#read_and_validate_file/1"},{"type":"module","title":"IgniterCss.Parsers.Formatter","doc":"Provides formatting functionality that requires igniter_js.\nThis module's functions will only work when igniter_js is included as a dependency.","ref":"IgniterCss.Parsers.Formatter.html"},{"type":"function","title":"IgniterCss.Parsers.Formatter.format/2","doc":"","ref":"IgniterCss.Parsers.Formatter.html#format/2"},{"type":"function","title":"IgniterCss.Parsers.Formatter.is_formatted/2","doc":"","ref":"IgniterCss.Parsers.Formatter.html#is_formatted/2"},{"type":"module","title":"IgniterCss.Parsers.Parser","doc":"CSS parsing and manipulation using Python's tinycss2 library.\n\nThis module provides functions to work with CSS files by leveraging\na Python toolkit built on tinycss2 for parsing, modifying, and analyzing CSS.\n\n> **Please note that the use of Python in Elixir will remain experimental for now,\n> as we continue to improve it over time and decide whether to adopt it fully.**","ref":"IgniterCss.Parsers.Parser.html"},{"type":"function","title":"IgniterCss.Parsers.Parser.add_hide_scrollbar_property/2","doc":"Adds a display: none property to the .hide-scrollbar class.\nIf the class doesn't exist, it creates it.","ref":"IgniterCss.Parsers.Parser.html#add_hide_scrollbar_property/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.add_hide_scrollbar_property/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.add_hide_scrollbar_property(css_code)\nupdated css with .hide-scrollbar having display: none\n```","ref":"IgniterCss.Parsers.Parser.html#add_hide_scrollbar_property/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.add_import/4","doc":"Adds an @import rule to the CSS if it doesn't already exist.","ref":"IgniterCss.Parsers.Parser.html#add_import/4"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.add_import/4","doc":"* `file_path_or_content` - The CSS code as a string or file path\n  * `import_url` - The URL or path to import (without quotes)\n  * `media_query` - Optional media query to apply to the import (e.g., \"screen and (max-width: 768px)\")\n                    or boolean false to indicate no media query\n  * `type` - `:content` or `:path` to specify if the first parameter is file content or a path","ref":"IgniterCss.Parsers.Parser.html#add_import/4-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.add_import/4","doc":"iex> IgniterCss.Parsers.CSS.Parser.add_import(css_code, \"styles.css\", false)\n    {:ok, :add_import, \"css with @import 'styles.css'; added\"}\n\n    iex> IgniterCss.Parsers.CSS.Parser.add_import(css_code, \"mobile.css\", \"screen and (max-width: 768px)\")\n    {:ok, :add_import, \"css with @import 'mobile.css' screen and (max-width: 768px); added\"}","ref":"IgniterCss.Parsers.Parser.html#add_import/4-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.add_vendor_prefixes/4","doc":"Adds vendor prefixes to specified CSS properties throughout the stylesheet.","ref":"IgniterCss.Parsers.Parser.html#add_vendor_prefixes/4"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.add_vendor_prefixes/4","doc":"* `css_code` - The CSS code as a string\n  * `property_name` - The CSS property to add prefixes to\n  * `prefixes` - List of prefixes to add (e.g., [\"-webkit-\", \"-moz-\"])","ref":"IgniterCss.Parsers.Parser.html#add_vendor_prefixes/4-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.add_vendor_prefixes/4","doc":"```elixir\niex> prefixes = [\"-webkit-\", \"-moz-\", \"-ms-\"]\niex> IgniterCss.Parsers.CSS.Parser.add_vendor_prefixes(css_code, \"user-select\", prefixes)\n\"updated css with vendor prefixes\"\n```","ref":"IgniterCss.Parsers.Parser.html#add_vendor_prefixes/4-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.analyze_css/2","doc":"Analyzes a CSS stylesheet and returns various statistics.","ref":"IgniterCss.Parsers.Parser.html#analyze_css/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.analyze_css/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.analyze_css(css_code)\n%{\n  \"selectors_count\" => 15,\n  \"unique_selectors\" => 12,\n  \"properties_count\" => 45,\n  \"unique_properties\" => 20,\n  ...\n}\n```","ref":"IgniterCss.Parsers.Parser.html#analyze_css/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.beautify/2","doc":"Beautifies a CSS stylesheet by adding proper indentation and formatting.\nWe recommend using `IgniterCss.Parsers.CSS.Formatter` module instead.","ref":"IgniterCss.Parsers.Parser.html#beautify/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.beautify/2","doc":"iex> IgniterCss.Parsers.CSS.Parser.beautify(css_code)\n    \".header {\n        color: #333;\n        background: #fff;\n    }\n\n    .footer {\n        color: #000;\n    }\"","ref":"IgniterCss.Parsers.Parser.html#beautify/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.extract_animations/2","doc":"Extracts all CSS animations and keyframes.","ref":"IgniterCss.Parsers.Parser.html#extract_animations/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.extract_animations/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.extract_animations(css_code)\n%{\n  \"fade-in\" => %{\n    \"keyframes\" => %{\n      \"0%\" => %{\"opacity\" => \"0\"},\n      \"100%\" => %{\"opacity\" => \"1\"}\n    },\n    \"used_by\" => [\".header\", \".modal\"]\n  }\n}\n```","ref":"IgniterCss.Parsers.Parser.html#extract_animations/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.extract_colors/2","doc":"Extracts all color values from a CSS stylesheet.","ref":"IgniterCss.Parsers.Parser.html#extract_colors/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.extract_colors/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.extract_colors(css_code)\n%{\n  \".header\" => [\"color: #333\", \"background-color: white\"],\n  \".footer\" => [\"color: rgba(0, 0, 0, 0.8)\"]\n}\n```","ref":"IgniterCss.Parsers.Parser.html#extract_colors/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.extract_media_queries/2","doc":"Extracts all media queries and their contents.","ref":"IgniterCss.Parsers.Parser.html#extract_media_queries/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.extract_media_queries/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.extract_media_queries(css_code)\n%{\n  \"(max-width: 768px)\" => [\n    %{\n      \"selector\" => \".header\",\n      \"properties\" => %{\"font-size\" => \"14px\"}\n    }\n  ]\n}\n```","ref":"IgniterCss.Parsers.Parser.html#extract_media_queries/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.get_selector_properties/3","doc":"Gets the CSS properties for a specific selector if it exists, or returns nil.","ref":"IgniterCss.Parsers.Parser.html#get_selector_properties/3"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.get_selector_properties/3","doc":"* `css_code` - The CSS code as a string\n  * `selector` - The CSS selector to check for","ref":"IgniterCss.Parsers.Parser.html#get_selector_properties/3-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.get_selector_properties/3","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.get_selector_properties(css_code, \".header\")\n%{\"color\" => \"blue\", \"font-size\" => \"16px\"}\n\niex> IgniterCss.Parsers.CSS.Parser.get_selector_properties(css_code, \"#nonexistent\")\nnil\n```","ref":"IgniterCss.Parsers.Parser.html#get_selector_properties/3-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.merge_stylesheets/1","doc":"Merges multiple CSS stylesheets into one, removing duplicates.","ref":"IgniterCss.Parsers.Parser.html#merge_stylesheets/1"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.merge_stylesheets/1","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.merge_stylesheets([css_code1, css_code2])\n\"merged css\"\n```","ref":"IgniterCss.Parsers.Parser.html#merge_stylesheets/1-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.minify/2","doc":"Minifies a CSS stylesheet by removing comments, whitespace, and unnecessary characters.\nWe recommend not using this.","ref":"IgniterCss.Parsers.Parser.html#minify/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.minify/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.minify(css_code)\n\".header{color:#333;background:#fff;}.footer{color:#000;}\"\n```","ref":"IgniterCss.Parsers.Parser.html#minify/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.modify_property/6","doc":"Modifies a property value for a specific selector.","ref":"IgniterCss.Parsers.Parser.html#modify_property/6"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.modify_property/6","doc":"* `css_code` - The CSS code as a string\n  * `selector` - The CSS selector to modify\n  * `property_name` - The property name to modify\n  * `new_value` - The new property value\n  * `important` - Whether to mark the property as !important (default: false)","ref":"IgniterCss.Parsers.Parser.html#modify_property/6-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.modify_property/6","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.modify_property(css_code, \".header\", \"color\", \"blue\")\n\"updated css with .header color: blue\"\n```","ref":"IgniterCss.Parsers.Parser.html#modify_property/6-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.remove_duplicates/2","doc":"Removes duplicate selectors and properties from CSS.","ref":"IgniterCss.Parsers.Parser.html#remove_duplicates/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.remove_duplicates/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.remove_duplicates(css_code)\n\"css without duplicates\"\n```","ref":"IgniterCss.Parsers.Parser.html#remove_duplicates/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.remove_import/3","doc":"Removes a specific @import rule from the CSS.","ref":"IgniterCss.Parsers.Parser.html#remove_import/3"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.remove_import/3","doc":"* `css_code` - The CSS code as a string\n  * `import_url` - The URL or path to remove (matches partial URL)","ref":"IgniterCss.Parsers.Parser.html#remove_import/3-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.remove_import/3","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.remove_import(css_code, \"styles.css\")\n\"css with @import url('styles.css') removed\"\n```","ref":"IgniterCss.Parsers.Parser.html#remove_import/3-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.remove_selector/3","doc":"Removes a CSS selector and all its properties.\n**Note**: If a block is empty after removal, it will be removed as well.","ref":"IgniterCss.Parsers.Parser.html#remove_selector/3"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.remove_selector/3","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.remove_selector(css_code, \".unused-class\")\n\"css without .unused-class\"\n```","ref":"IgniterCss.Parsers.Parser.html#remove_selector/3-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.replace_selector_rule/4","doc":"Replaces an entire CSS rule for a specific selector with new declarations.","ref":"IgniterCss.Parsers.Parser.html#replace_selector_rule/4"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.replace_selector_rule/4","doc":"* `css_code` - The CSS code as a string\n  * `selector` - The CSS selector to replace\n  * `new_declarations` - The new CSS declarations as a string (without curly braces)","ref":"IgniterCss.Parsers.Parser.html#replace_selector_rule/4-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.replace_selector_rule/4","doc":"iex> IgniterCss.Parsers.CSS.Parser.replace_selector_rule(css_code, \".header\", \"color: blue; font-size: 20px; padding: 10px;\")\n    \"css with .header rule replaced\"","ref":"IgniterCss.Parsers.Parser.html#replace_selector_rule/4-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.selector_exists?/3","doc":"Checks if a specific CSS selector exists in the stylesheet.","ref":"IgniterCss.Parsers.Parser.html#selector_exists?/3"},{"type":"function","title":"Parameters - IgniterCss.Parsers.Parser.selector_exists?/3","doc":"* `css_code` - The CSS code as a string\n  * `selector` - The CSS selector to check for","ref":"IgniterCss.Parsers.Parser.html#selector_exists?/3-parameters"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.selector_exists?/3","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.selector_exists?(css_code, \".header\")\ntrue\n\niex> IgniterCss.Parsers.CSS.Parser.selector_exists?(css_code, \"#nonexistent\")\nfalse\n```","ref":"IgniterCss.Parsers.Parser.html#selector_exists?/3-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.sort_properties/2","doc":"Sorts CSS properties alphabetically within each rule.","ref":"IgniterCss.Parsers.Parser.html#sort_properties/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.sort_properties/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.sort_properties(css_code)\n\".header {\n    background: #fff;\n    color: #333;\n    font-size: 16px;\n}\"\n```","ref":"IgniterCss.Parsers.Parser.html#sort_properties/2-examples"},{"type":"function","title":"IgniterCss.Parsers.Parser.validate_css/2","doc":"Checks if the CSS code is valid by attempting to parse it.\nReturns :ok if valid, or {:error, reason} if invalid.","ref":"IgniterCss.Parsers.Parser.html#validate_css/2"},{"type":"function","title":"Examples - IgniterCss.Parsers.Parser.validate_css/2","doc":"```elixir\niex> IgniterCss.Parsers.CSS.Parser.validate_css(css_code)\n:ok\n\niex> IgniterCss.Parsers.CSS.Parser.validate_css(\"invalid { css\")\n{:error, \"Parse error at line 1, column 10: Missing closing brace\"}\n```","ref":"IgniterCss.Parsers.Parser.html#validate_css/2-examples"},{"type":"extras","title":"Home","doc":"[![CI](https://github.com/ash-project/igniter_css/actions/workflows/elixir.yml/badge.svg)](https://github.com/ash-project/igniter_css/actions/workflows/elixir.yml)\n[![Hex version badge](https://img.shields.io/hexpm/v/igniter_css.svg)](https://hex.pm/packages/igniter_css)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/igniter_css)\n\n# IgniterCss\n\nIgniterCss is CSS patching functionality for [Igniter](https://hexdocs.pm/igniter)","ref":"readme.html"},{"type":"extras","title":"Installation - Home","doc":"IgniterCss can be added to an existing elixir project by adding it to your dependencies:\n\n```elixir\n{:igniter_css, \"~> 0.1.0\", only: [:dev, :test]}\n```","ref":"readme.html#installation"},{"type":"extras","title":"Status - Home","doc":"We are still working on getting this ready for an initial release.\n\nThe initial codemods will be limited to specific transformations. This is not intended to\nbe a toolkit (yet) for writing any arbitrary transformation like `Igniter` is for `Elixir`.\nWe will likely provide a way to do this by the user providing rust code and using our tools\nto hook it up to igniter.","ref":"readme.html#status"},{"type":"extras","title":"Changelog for IgniterCss 0.1.0","doc":"# Changelog for IgniterCss 0.1.0","ref":"changelog.html"},{"type":"extras","title":"Features: - Changelog for IgniterCss 0.1.0","doc":"- feat(css): add CSS parser with AST transformation support\n [#1](https://github.com/ash-project/igniter_css/pull/1)","ref":"changelog.html#features"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}